/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of unLZMA.xs. Do not edit this file, edit unLZMA.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "unLZMA.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "LzmaDecode.c"

#include "ppport.h"

typedef struct Content_s
{
	char *content;
	unsigned long size;
} Content;

/* 
Converted from LzmaTest.c to .xs by Fabien POTENCIER
LZMA SDK 4.01 Copyright (c) 1999-2004 Igor Pavlov (2004-02-15)
*/

size_t MyReadFile(FILE *file, void *data, size_t size)
{
  return ((size_t)fread(data, 1, size, file) == (size_t)size);
}

#ifdef _LZMA_IN_CB
typedef struct _CBuffer
{
  ILzmaInCallback InCallback;
  unsigned char *Buffer;
  unsigned int Size;
} CBuffer;

int LzmaReadCompressed(void *object, unsigned char **buffer, unsigned int *size)
{
  CBuffer *bo = (CBuffer *)object;
  *size = bo->Size; /* You can specify any available size here */
  *buffer = bo->Buffer;
  bo->Buffer += *size; 
  bo->Size -= *size;
  return LZMA_RESULT_OK;
}
#endif

int LzmaUncompressData(Content *pIn, Content *pOut, unsigned char properties[5], char *rs)
{
  unsigned int outSizeProcessed, lzmaInternalSize;
  void *lzmaInternalData;
  int lc, lp, pb;
  int res;
  #ifdef _LZMA_IN_CB
  CBuffer bo;
  #endif

  for (pb = 0; properties[0] >= (9 * 5); 
    pb++, properties[0] -= (9 * 5));
  for (lp = 0; properties[0] >= 9; 
    lp++, properties[0] -= 9);
  lc = properties[0];

  lzmaInternalSize = (LZMA_BASE_SIZE + (LZMA_LIT_SIZE << (lc + lp)))* sizeof(CProb);

  #ifdef _LZMA_OUT_READ
  lzmaInternalSize += sizeof(LzmaVarState);
  #endif

  New(0, pOut->content, pOut->size, char);
  if (pOut->content == 0)
  {
    sprintf(rs + strlen(rs), "can't allocate");
    return 1;
  }

  New(0, lzmaInternalData, lzmaInternalSize, char);
  if (lzmaInternalData == 0)
  {
    sprintf(rs + strlen(rs), "can't allocate");
    return 1;
  }

  #ifdef _LZMA_IN_CB
  bo.InCallback.Read = LzmaReadCompressed;
  bo.Buffer = (unsigned char *)pIn->content;
  bo.Size = pIn->size;
  #endif

  #ifdef _LZMA_OUT_READ
  {
    UInt32 nowPos;
    unsigned char *dictionary;
    UInt32 dictionarySize = 0;
    int i;
    for (i = 0; i < 4; i++)
      dictionarySize += (UInt32)(properties[1 + i]) << (i * 8);
    New(0, dictionary, dictionarySize, char);
    if (dictionary == 0)
    {
      sprintf(rs + strlen(rs), "can't allocate");
      Safefree(lzmaInternalData);
      return 1;
    }
    LzmaDecoderInit((unsigned char *)lzmaInternalData, lzmaInternalSize,
        lc, lp, pb,
        dictionary, dictionarySize,
        #ifdef _LZMA_IN_CB
        &bo.InCallback
        #else
        (unsigned char *)pIn->content, pIn->size
        #endif
        );
    for (nowPos = 0; nowPos < pOut->size;)
    {
      UInt32 blockSize = pOut->size - nowPos;
      UInt32 kBlockSize = 0x10000;
      if (blockSize > kBlockSize)
        blockSize = kBlockSize;
      res = LzmaDecode((unsigned char *)lzmaInternalData, 
      ((unsigned char *)pOut->content) + nowPos, blockSize, &outSizeProcessed);
      if (res != 0)
      {
        sprintf(rs + strlen(rs), "error = %d\n", res);
	Safefree(lzmaInternalData);
        return 1;
      }
      if (outSizeProcessed == 0)
      {
        pOut->size = nowPos;
        break;
      }
      nowPos += outSizeProcessed;
    }
    Safefree(dictionary);
  }

  #else
  res = LzmaDecode((unsigned char *)lzmaInternalData, lzmaInternalSize,
      lc, lp, pb,
      #ifdef _LZMA_IN_CB
      &bo.InCallback,
      #else
      (unsigned char *)pIn->content, pIn->size,
      #endif
      (unsigned char *)pOut->content, pOut->size, &outSizeProcessed);
  pOut->size = outSizeProcessed;
  #endif

  if (res != 0)
  {
    sprintf(rs + strlen(rs), "error = %d\n", res);
    Safefree(lzmaInternalData);
    return 1;
  }

    Safefree(lzmaInternalData);

  return 0;
}

int LzmaUncompressFile(char *filename, Content *pOut, char *rs)
{
  FILE *inputHandle;
  unsigned int length;
  Content *pIn;
  unsigned char properties[5];
  int ii, ret;

  inputHandle = fopen(filename, "rb");
  if (inputHandle == 0)
  {
    sprintf(rs + strlen(rs), "open input file error");
    return 1;
  }

  fseek(inputHandle, 0, SEEK_END);
  length = (unsigned int)ftell(inputHandle);
  fseek(inputHandle, 0, SEEK_SET);

  if (!MyReadFile(inputHandle, properties, sizeof(properties)))
  {
    fclose(inputHandle);
    return 1;
  }

  pOut->size = 0;
  for (ii = 0; ii < 4; ii++)
  {
    unsigned char b;
    if (!MyReadFile(inputHandle, &b, sizeof(b)))
    {
      fclose(inputHandle);
      return 1;
    }
    pOut->size += (b) << (ii * 8);
  }

  if (pOut->size == 0xFFFFFFFF)
  {
    sprintf(rs + strlen(rs), "stream version is not supported");
    fclose(inputHandle);
    return 1;
  }

  for (ii = 0; ii < 4; ii++)
  {
    unsigned char b;
    if (!MyReadFile(inputHandle, &b, sizeof(b)))
      return 1;
    if (b != 0)
    {
      sprintf(rs + strlen(rs), "too long file");
      fclose(inputHandle);
      return 1;
    }
  }

    New(0, pIn, 1, Content);

  pIn->size = length - 13;
    New(0, pIn->content, pIn->size, char);
  if (pIn->content == 0)
  {
    sprintf(rs + strlen(rs), "can't allocate");
    Safefree(pIn);
    fclose(inputHandle);
    return 1;
  }
  if (!MyReadFile(inputHandle, pIn->content, pIn->size))
  {
    sprintf(rs + strlen(rs), "can't read");
    Safefree(pIn->content);
    Safefree(pIn);
    fclose(inputHandle);
    return 1;
  }

  fclose(inputHandle);

  if (properties[0] >= (9*5*5))
  {
    sprintf(rs + strlen(rs), "Properties error");
    Safefree(pIn->content);
    Safefree(pIn);
    return 1;
  }

  /* empty file: no need to uncompress data */
  if (pOut->size == (unsigned long)0)
  {
    Safefree(pIn->content);
    Safefree(pIn);
    return 0;
  }

  ret = LzmaUncompressData(pIn, pOut, properties, rs);

    Safefree(pIn->content);
    Safefree(pIn);

  return ret;
}

#line 271 "unLZMA.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 415 "unLZMA.c"

XS_EUPXS(XS_Compress__unLZMA_uncompressdata); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Compress__unLZMA_uncompressdata)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "content, size, sizeout, properties");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	content = (char *)SvPV_nolen(ST(0))
;
	unsigned int	size = (unsigned int)SvUV(ST(1))
;
	unsigned int	sizeout = (unsigned int)SvUV(ST(2))
;
	unsigned char *	properties = (unsigned char *)SvPV_nolen(ST(3))
;
#line 272 "unLZMA.xs"
	char sz[800] = { 0 };
	Content *pIn, *pOut;
	int code = 0;
	SV *errsv;

        New(0, pIn, 1, Content);
	pIn->content = content;
	pIn->size = size;

        New(0, pOut, 1, Content);
	pOut->content = NULL;
	pOut->size = sizeout;

	code = LzmaUncompressData(pIn, pOut, properties, sz);

	errsv = get_sv("@", TRUE);

	/* Error */
	if (code)
	{
		sv_setpv(errsv, sz);
		Safefree(pIn->content);
		Safefree(pIn);
		Safefree(pOut->content);
		Safefree(pOut);
		XSRETURN_UNDEF;
	}

	sv_setpv(errsv, "");
	XPUSHs(sv_2mortal(newSVpvn(pOut->content, pOut->size)));
	Safefree(pIn);
	Safefree(pOut->content);
	Safefree(pOut);
	XSRETURN(1);
#line 469 "unLZMA.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Compress__unLZMA_uncompressfile); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Compress__unLZMA_uncompressfile)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "filename");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	filename = (char *)SvPV_nolen(ST(0))
;
#line 311 "unLZMA.xs"
	char sz[800] = { 0 };
	int code = 0;
	unsigned int size = 0;
	Content *pContent;
	SV *errsv;

        New(0, pContent, 1, Content);
	pContent->content = NULL;
	pContent->size = 0;

	code = LzmaUncompressFile(filename, pContent, sz);

	errsv = get_sv("@", TRUE);

	/* Error */
	if (code)
	{
		sv_setpv(errsv, sz);
		Safefree(pContent->content);
		Safefree(pContent);
		XSRETURN_UNDEF;
	}

	sv_setpv(errsv, "");
        if (pContent->size) {
 		XPUSHs(sv_2mortal(newSVpvn(pContent->content, pContent->size)));
	} else {
		XPUSHs(sv_2mortal(newSVpvn("", pContent->size))); /* the empty string */
        }
	Safefree(pContent->content);
	Safefree(pContent);
	XSRETURN(1);
#line 520 "unLZMA.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Compress__unLZMA); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Compress__unLZMA)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Compress::unLZMA::uncompressdata", XS_Compress__unLZMA_uncompressdata);
        newXS_deffile("Compress::unLZMA::uncompressfile", XS_Compress__unLZMA_uncompressfile);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
